"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = exports.plugin = void 0;
var graphql_1 = require("graphql");
var TypedDocumentVisitor_1 = __importDefault(require("./visitors/TypedDocumentVisitor"));
var plugin = function (_schema, documents, _a) {
    var config = {};
    var output = [];
    documents.forEach(function (document) {
        if (!document.location) {
            throw new Error("Missing document location");
        }
        if (!document.document) {
            throw new Error("Missing document node");
        }
        var visitor = new TypedDocumentVisitor_1.default(output, document.location, config);
        graphql_1.visit(document.document, visitor);
    });
    var content = output.join("\n\n");
    return {
        prepend: content !== ""
            ? [
                'import { TypedDocumentNode } from "@graphql-typed-document-node/core";\n',
            ]
            : [],
        content: content,
    };
};
exports.plugin = plugin;
var validate = function () { return undefined; };
exports.validate = validate;
